'FFSubmenu=Tools
'FFName=Stapelbeschnitt

' ********************************************************************
' Stapelbeschnitt.vbs (Script fr FixFoto)
' von Harald Maeckler, Dsseldorf 2009 - 2011
'
' Funktion:	Bilder werden  auf ein festzulegendes Seitenverhltnis beschnitten.
'
' Version 1.08a v. 04.03.2011	- Abfangen von Fehleingaben beim Seitenverhltnis verbessert
' Version 1.08 vom 03.03.2011	- Fehleingaben bei Seitenverhltnis Neu abgefangen
'									- in der Benennung wird '/' automatisch durch ':' ersetzt
'									- beim Seitenverhltnis darf keine 0 eingegeben werden
' Version 1.07 vom 02.03.2011	- Unterstriche bei Prfix und Suffix entfallen
'								- neue Seitenverhltnisse knnen als Dezimalzahl oder als Verhltnis
'									mit Trennzeichen : oder / eingegeben werden
'								- von Seitenverhltnisse < 1 wird  automatisch der Kehrwert gebildet
' Version 1.06 vom 01.03.2011	- Speicheroptionen berschreiben/mit Prfix/mit Suffix
'									hinzugefgt
'								- Seitenverhltniseingabe Neu berarbeitet
' Version 1.05 vom 25.11.2010	- Markierung im Dialog Ausschneiden
'									der FF-Version 3.02.25 angepasst
' Version 1.04 vom 19.11.2009	- Meldung ".. nicht beschnitten" entfernt
'									Bug beim zhlen der bearbeiteten Bilder beseitigt
' Version 1.03 vom 18.11.2009	- Entsprechen die Schnittmarken +/- Toleranz dem Original
'									bleibt das Bild unverndert (siehe Kurzbeschreibung)
' Version 1.02 vom 17.11.2009	- Stand.-Seitenverhltnisse erweitert
' Version 1.01 vom 16.11.2009	- Kurzbeschreibung
' Version 1.00 vom 13.11.2009	- Betaversion
'
'** Start Kurzbeschreibung *******************************************
' Stapelbeschnitt / Version 1.08a
' ===================
' Bilder werden  auf ein festzulegendes Seitenverhltnis beschnitten und gem Speicheroptionen
' und Ablageort abgespeichert.
' Ein Sonderfall liegt vor, wenn die Schnittmarken bei Ausfhrung des Dialogs Aussschneiden max.
' +/- 0,5% vom Originalformat des Bildes abweichen. Es erfolgt dann kein Speichervorgang und 
' damit auch keine ggf. aktivierte Lschung der Exif-/IPTC-Daten. Ist als Ablageort ein Ablage-
' ordner definiert, wird das Bild verlustfrei in dieses Verzeichnis kopiert.
'
' Auswahl
' ----------
' Man kann sich entscheiden, ob alle oder nur markierte Bilder der Computeransicht oder
' der aktiven Bilderliste beschnitten werden sollen. Die Bearbeitung von Fotos in einer Bilder-
' liste ist allerdings erst ab FixFoto-Version 2.90 mglich. Ist eine ltere Version instal-
' liert, erfolgt ein entsprehender Hinweis.
' 
' Zielvorgaben
' ----------------
' Aus einer Liste kann ein Seitenverhltnis ausgewhlt werden.
' Die Liste kann aber auch individuellen Wnschen angepasst werden indem Seitenverhltnisse
' gelscht oder hinzugefgt werden. Mit 'Standard' kann man jederzeit den Ursprungszustand
' wieder herstellen.
' Bei Definition eines neuen Seitenverhltnisses muss eine beliebige Benennung und eine
' Seitenverhltniszahl eingegeben werden.
' In der Benennung ist das Zeichen '/' nicht erlaubt; es wird automatisch durch das Zeichen
' ':' ersetzt.
' Die Seitenverhltniszahl kann als Dezimalzahl oder als Verhltnis mit Trennzeichen ':' oder
' '/' eingegeben werden. 
'
' Speicheroptionen
' ---------------------
' Die Speicherqualitt sollte zwischen 70 und 100 liegen. Bei der Vorgabe 0 wird die in FF
' fr JPG-Bildern eingestellte Speicherqualitt verwendet; bei TIFF-Bildern wird bei 0 nicht 
' komprimiert.
' Ist 'Exif + IPTC lschen' aktiviert, werden diese Daten gelscht.
'
' Dialog Ausschneiden
' ------------------------
' Fr jedes ausgewhlte Bild wird der Dialog Ausschneiden mit den dem gewhlten Seitenver-
' hltnis entsprechenden Schnittmarken aufgerufen. Diese knnen nach Belieben verschoben und
' proportional verndert werden. Zur Orientierung kann eine Markierung aus einer Liste ausge-
' whlt werden, die dann innerhalb der Schnittmarken eingeblendet wird.
'
' Ablageort
' ------------
' Der Ablageort fr die beschnittenen Bilder kann das Originalverzeichnis oder ein frei whl-
' barer Ordner sein.
'
' Speichern
' ------------
' Normalerweise wird berprft, ob ein Bild mit gleichem Namen im Ablageordner bereits existiert.
' Ist dies der Fall, wird nachgefragt, ob es berschrieben werden soll. 
' Wenn die Option 'ohne Rckfrage berschreiben' akitiviert ist, erfolgt keine Prfung.
'
' Dem Namen des Originalbildes kann zum Abspeichern eine vorgebbare Prfix bzw. Suffix hinzu-
' gefgt werden. So wird beispielsweise aus 'Testbild.jpg' bei der Option Prfix 'CutTestbild.jpg'
' und bei der Option Suffix 'TestbildCut.jpg'. 
' Es wird empfohlen, dem Prfix- bzw. Suffix-Text einen Unterstrich hinzu zu fgen.
'
'
' ?, vorzeitiger Abbruch, Abbrechen und Start
' ------------------------------------------------------
' Die Befehle ?, Abbrechen und Start erklren sich von selbst.
' Zum vorzeitigen Abbruch mit der Backspacetaste hier eine Erluterung:
' Bei groen Bildermengen kann es sein, dass man den mit Start angestoenen Vorgang frhzeitig 
' beenden will. Da das Skript immer bei Anzeige des Dialogs Ausschneiden angehalten wird, hlt
' man am besten die Backspace-Taste beim Beenden des Dialogs fest bis der vorzeitige Abbruch 
' gemeldet wird. Es wird angezeigt wieviele Bilder bereits von der Gesamtanzahl bearbeitet
' wurden und es kann entschieden werden, ob das Skript fortgesetzt oder wirklich vorzeitg be-
' endet werden soll.
'
' Deinstallation des Skripts 'Stapelbeschnitt'
' ===========================
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen ange-
' boten, davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach 
' wird die Skriptdatei gelscht und abschlieend die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript aus 
' der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

const SkriptName = "Stapelbeschnitt.vbs"			'Skriptname
const RegSchluessel = "FF_Stapelbeschnitt"			'Registryschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim SkriptKill,Antwort,TempFile								'Lschroutine

const StdSeitenverhaeltnisse = "1:1/9:7 (Passbild)/4:3/7:5/Din A/3:2/Gold. Schnitt/16:10/16:9/Original/"
const StdSeitenverhWerte     = "1/1,286/1,333/1,4/1,414/1,5/1,618/1,6/1,778/ogn/"
Dim StdMarkierung
Dim n,img,Auswahl,ListeBilder,Bild,Anzahl,VAbbruch
Dim Bilder,Qualitaet,boolExifLoeschen,flagOrigV,flagAblageV,Ablage
Dim Seitenverhaeltnisse,SeitenverhWerte
Dim SV_Array, SV_Werte, SV_Soll, SVwert
Dim MK_Array,MKgew,MKwert
Dim NurKopieren,BildOriginal
Dim flag_ohneRsp,flag_mPraefix,flag_mSuffix,PS_Text
const NSp_SMgO = true	'Nicht speichern wenn Schnittmarken = Original
const TolSM_Og = 0.5	'max. Abweichung in % zwischen Schnittmarken und Original

Dim objFS,WshShell											'Objekte

Abbruch = false
'---------------------------------------------------------------------
call main
'---------------------------------------------------------------------
Sub main
Dim msg

Anzahl = 0
VAbbruch = false

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	n = FF_GetImageCount
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if not Version_OK("3.02.25") then
	StdMarkierung = "Aus-nicht prop./Goldener Schnitt/Drittel/Deutschland ab 10/Deutschland bis 9/Keine Markierung"
	'0 - Markierung "Aus", proportional nicht markiert
	'1 - Markierung "Goldener Schnitt", proportional markiert
	'2 - Markierung "Drittel", proportional markiert
	'3 - Markierung "Deutschland ab 10", proportional markiert
	'4 - Markierung "Deutschland bis 9", proportional markiert
	'5 - Markierung "Aus", proportional markiert
else
	StdMarkierung = "Keine Markierung/Goldener Schnitt/Goldene Spirale l. ob./Goldene Spirale r. ob./Goldene Spirale r. un./Goldene Spirale l. un./Drittel/Deutschland ab 10/Deutschland bis 9"
	'0 - Markierung "Aus", proportional markiert
	'1 - Markierung "Goldener Schnitt", proportional markiert
	'2 - Markierung "Goldene Spirale l. ob."
	'3 - Markierung "Goldene Spirale r. ob."
	'4 - Markierung "Goldene Spirale r. un."
	'5 - Markierung "Goldene Spirale l. un."
	'6 - Markierung "Drittel", proportional markiert
	'7 - Markierung "Deutschland ab 10", proportional markiert
	'8 - Markierung "Deutschland bis 9", proportional markiert
end if
	
'** Start Dialog Stapelbeschnitt **
FF_AddDialog "Stapelbeschnitt",245,208
FF_AddControl "Stapelbeschnitt","Auswahl","GROUP",5,5,114,50
FF_AddControl "Stapelbeschnitt","allCV","BOOL",10,14,8,8
FF_SetControlStyle "Stapelbeschnitt","allCV",16384
FF_AddControl "Stapelbeschnitt","alle Bilder der Computer-Ansicht","STATIC",21,12,90,11
FF_AddControl "Stapelbeschnitt","selCV","BOOL",10,24,8,8
FF_SetControlStyle "Stapelbeschnitt","selCV",16384
FF_AddControl "Stapelbeschnitt","markierte Bilder der Computer-Ansicht","STATIC",21,22,96,11
FF_AddControl "Stapelbeschnitt","allBL","BOOL",10,34,8,8
FF_SetControlStyle "Stapelbeschnitt","allBL",16384
FF_AddControl "Stapelbeschnitt","alle Bilder der aktiven Bilderliste","STATIC",21,32,96,11
FF_AddControl "Stapelbeschnitt","selBL","BOOL",10,44,8,8
FF_SetControlStyle "Stapelbeschnitt","selBL",16384
FF_AddControl "Stapelbeschnitt","markierte Bilder der aktiven Bilderliste","STATIC",21,42,96,11
FF_AddControl "Stapelbeschnitt","Zielvorgaben","GROUP",125,5,114,50
FF_AddControl "Stapelbeschnitt","Seitenverhltnis","STATIC",130,15,42,10
FF_AddControl "Stapelbeschnitt","lange zur kurzen Seite","STATIC",130,23,59,10
FF_AddControl "Stapelbeschnitt","SVauswahl","COMBO",188,18,46,10
FF_AddControl "Stapelbeschnitt","Lschen","BUTTON",130,37,33,11
FF_AddControl "Stapelbeschnitt","Neu","BUTTON",166,37,32,11
FF_AddControl "Stapelbeschnitt","Standard","BUTTON",201,37,33,11
FF_AddControl "Stapelbeschnitt","Dialog Ausschneiden","GROUP",125,59,114,32
FF_AddControl "Stapelbeschnitt","Markierung","STATIC",131,71,33,10
FF_AddControl "Stapelbeschnitt","MKauswahl","COMBO",164,71,70,10
FF_AddControl "Stapelbeschnitt","Speicheroptionen","GROUP",5,59,114,32
FF_AddControl "Stapelbeschnitt","Speicherqualitt","STATIC",21,67,42,10
FF_AddControl "Stapelbeschnitt","Qualitaet","SLEDIT",62,67,16,10
FF_SetControlStyle "Stapelbeschnitt","Qualitaet",8193
FF_AddControl "Stapelbeschnitt","Wert 0 =","STATIC",85,64,24,10
FF_AddControl "Stapelbeschnitt","FF-Einstellung","STATIC",83,71,34,10
FF_AddControl "Stapelbeschnitt","boolExifLoeschen","BOOL",11,80,8,8
FF_SetControlStyle "Stapelbeschnitt","boolExifLoeschen",16384
FF_AddControl "Stapelbeschnitt","Exif- und IPTC-Daten lschen","STATIC",21,79,77,10
FF_AddControl "Stapelbeschnitt","Ablageort","GROUP",5,95,234,47
FF_AddControl "Stapelbeschnitt","flagOrigV","BOOL",11,105,8,8
FF_SetControlStyle "Stapelbeschnitt","flagOrigV",16384
FF_AddControl "Stapelbeschnitt","im Originalverzeichnis","STATIC",21,104,66,10
FF_AddControl "Stapelbeschnitt","flagAblageV","BOOL",11,115,8,8
FF_SetControlStyle "Stapelbeschnitt","flagAblageV",16384
FF_AddControl "Stapelbeschnitt","im Ablageordner","STATIC",21,114,45,10
FF_AddControl "Stapelbeschnitt","Ablage","SLEDIT",11,127,210,10
FF_AddControl "Stapelbeschnitt","...","BUTTON",224,127,10,10
FF_AddControl "Stapelbeschnitt","Speichern","GROUP",5,146,234,27
FF_AddControl "Stapelbeschnitt","flag_ohneRsp","BOOL",11,157,8,8
FF_AddControl "Stapelbeschnitt"," ohne Rckfrage berschreiben","STATIC",21,156,78,9
FF_AddControl "Stapelbeschnitt","flag_mPraefix","BOOL",135,153,8,8
FF_SetControlStyle "Stapelbeschnitt","flag_mPraefix",16384
FF_AddControl "Stapelbeschnitt","mit Prfix speichern","STATIC",147,151,50,10
FF_AddControl "Stapelbeschnitt","flag_mSuffix","BOOL",135,163,8,8
FF_SetControlStyle "Stapelbeschnitt","flag_mSuffix",16384
FF_AddControl "Stapelbeschnitt","mit Suffix speichern","STATIC",147,162,50,10
FF_AddControl "Stapelbeschnitt","PS_Text","SLEDIT",201,157,33,10
FF_SetControlStyle "Stapelbeschnitt","PS_Text",1
FF_AddControl "Stapelbeschnitt","Fortschritt","PROGRESS",5,179,234,6
FF_AddControl "Stapelbeschnitt","?","BUTTON",11,192,11,11
FF_AddControl "Stapelbeschnitt","Vorzeitiger Abbruch mit","STATIC",33,192,57,10
FF_AddControl "Stapelbeschnitt","-","STATIC",92,191,33,12
FF_SetControlStyle "Stapelbeschnitt","-",18
FF_AddControl "Stapelbeschnitt","Backspace","STATIC",94,192,29,9
FF_SetControlStyle "Stapelbeschnitt","Backspace",1
FF_AddControl "Stapelbeschnitt","- Taste","STATIC",126,192,23,10
FF_AddControl "Stapelbeschnitt","Abbrechen","BUTTON",170,192,30,11
FF_AddControl "Stapelbeschnitt","Start","BUTTON",206,192,28,11
FF_AddControl "Stapelbeschnitt","&d","BUTTON",39,205,1,1
'** End Dialog Stapelbeschnitt **

call RegistryLesen
if Abbruch then exit sub
FF_ActivateControl "Stapelbeschnitt","&d"

do
	Select Case FF_ShowDialog ("Stapelbeschnitt")
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			Abbruch = true
			SkriptKill = true
			exit do
		end if
	Case "allCV"		'Auswahl alle in der Comp.-Ansicht
		Auswahl = 0
		FF_SetControl "Stapelbeschnitt","allCV",1
		FF_SetControl "Stapelbeschnitt","selCV",0
		FF_SetControl "Stapelbeschnitt","allBL",0
		FF_SetControl "Stapelbeschnitt","selBL",0
	Case "selCV"		'Auswahl markierte in der Comp.-Ansicht
		Auswahl = 1
		FF_SetControl "Stapelbeschnitt","allCV",0
		FF_SetControl "Stapelbeschnitt","selCV",1
		FF_SetControl "Stapelbeschnitt","allBL",0
		FF_SetControl "Stapelbeschnitt","selBL",0	
	Case "allBL"		'Auswahl alle in der aktuellen Bilderliste
		Auswahl = 2
		FF_SetControl "Stapelbeschnitt","allCV",0
		FF_SetControl "Stapelbeschnitt","selCV",0
		FF_SetControl "Stapelbeschnitt","allBL",1
		FF_SetControl "Stapelbeschnitt","selBL",0	
	Case "selBL"		'Auswahl markierte in der aktuellen Bilderliste
		Auswahl = 3
		FF_SetControl "Stapelbeschnitt","allCV",0
		FF_SetControl "Stapelbeschnitt","selCV",0
		FF_SetControl "Stapelbeschnitt","allBL",0
		FF_SetControl "Stapelbeschnitt","selBL",1
	Case "Lschen"						'Seitenverhltnis lschen
		SV_Soll = FF_GetControl ("Stapelbeschnitt","SVauswahl")
		Antwort = msgbox ("Soll das Seitenverhltnis '" & SV_Soll & "' wirklich gelscht werden?",vbYesNo or vbQuestion, "Seitenverhltnis")
		if Antwort = vbYes then
			SV_Array = split(Seitenverhaeltnisse,"/",-1)
			SV_Werte = split(SeitenverhWerte,"/",-1)
			Seitenverhaeltnisse = ""
			SeitenverhWerte = ""
			Msg = ""	
			for n = 0 to ubound(SV_Array)-1
				if SV_Array(n) <> SV_Soll then
					Seitenverhaeltnisse = Seitenverhaeltnisse	& SV_Array(n) & "/"
					SeitenverhWerte = SeitenverhWerte & SV_Werte(n) & "/"
					Msg = Msg & vbNewLine & SV_Array(n) & " = " & SV_Werte(n)
				end if
			next
			FF_SetControl "Stapelbeschnitt","SVauswahl",""
			SV_Array = split(Seitenverhaeltnisse,"/",-1)
			for n = 0 to ubound(SV_Array)-1
				FF_SetControl "Stapelbeschnitt","SVauswahl",SV_Array(n)
			next
		end if
	Case "Neu"						'Neues Seitenverhltnis
		call Seitenverhaeltnis
	Case "Standard"						'Standard-Seitenverhltnis wieder herstellen
		Antwort = msgbox ("Sollen die Standardwerte fr Seitenverhltnisse" & vbNewLine & _
				"wieder hergestellt werden?" & vbNewLine & vbNewLine & _
				"Alle bisherigen nderungen werden dabei verworfen!",vbYesNo or vbQuestion, "Seitenverhltnisse")
		if Antwort = vbYes then
			Seitenverhaeltnisse = StdSeitenverhaeltnisse
			SeitenverhWerte     = StdSeitenverhWerte
			FF_SetControl "Stapelbeschnitt","SVauswahl",""
			SV_Array = split(Seitenverhaeltnisse,"/",-1)
			for n = 0 to ubound(SV_Array)-1
				FF_SetControl "Stapelbeschnitt","SVauswahl",SV_Array(n)
			next
		end if
	Case "flagAblageV"
		FF_SetControl "Stapelbeschnitt","flagAblageV",1
		FF_SetControl "Stapelbeschnitt","flagOrigV",0
		FF_EnableControl "Stapelbeschnitt","Ablage",true
		FF_EnableControl "Stapelbeschnitt","...",true
	Case "flagOrigV"
		FF_SetControl "Stapelbeschnitt","flagAblageV",0
		FF_SetControl "Stapelbeschnitt","flagOrigV",1
		FF_EnableControl "Stapelbeschnitt","Ablage",false
		FF_EnableControl "Stapelbeschnitt","...",false
	Case "..."					'Ablageordner
		FF_SetCurrentPath FF_GetImagePath
		Ablage = FF_EnterPath(false,"Wahl des Ablageordners")
		if len(Ablage) > 2 then 
			if right(Ablage,1) <> "\" then Ablage = Ablage & "\"
			FF_SetControl "Stapelbeschnitt","Ablage",Ablage
		end if
	Case "flag_mPraefix"
		if FF_GetControl ("Stapelbeschnitt","flag_mPraefix") = 1 then
			FF_SetControl "Stapelbeschnitt","flag_mSuffix",0
		end if
	Case "flag_mSuffix"
		if FF_GetControl ("Stapelbeschnitt","flag_mSuffix") = 1 then
			FF_SetControl "Stapelbeschnitt","flag_mPraefix",0
		end if
	Case "?"
		'FF_SetControl "Stapelbeschnitt","Fortschritt",65	'############## nur fr Screenshot
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "Start"
		Abbruch = false
		call WerteAuslesen
		call Kontrolle
		if not Abbruch then	
			call Schleife
			exit do
		end if
	Case "CANCEL","Abbrechen"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Stapelbeschnitt")
if not Abbruch then msgbox "Von " & img+1 & " Bildern wurden " & Anzahl & _
						   " Bilder angepasst.",vbInformation,"Schlussmeldung"
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'---------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

'Auswahl
if FF_GetControl ("Stapelbeschnitt","allCV") = "1" then Auswahl = 0	'alle Dateien der Computeransicht
if FF_GetControl ("Stapelbeschnitt","selCV") = "1" then Auswahl = 1	'markierte Dateien der Computeransich
if FF_GetControl ("Stapelbeschnitt","allBL") = "1" then Auswahl = 2	'alle Dateien der aktuellen Bilderliste
if FF_GetControl ("Stapelbeschnitt","selBL") = "1" then Auswahl = 3	'markierte Dateien der aktuellen Bilderliste

'Gewhltes Seitenverhltnis SV_Soll und der dazugehrige Wert SVwert (B/H)
SV_Soll = FF_GetControl ("Stapelbeschnitt","SVauswahl")

SV_Array = split(Seitenverhaeltnisse,"/",-1)
SV_Werte = split(SeitenverhWerte,"/",-1)
for n = 0 to ubound(SV_Array)-1
	if SV_Array(n) = SV_Soll then 
		SVwert = SV_Werte(n) *1
		exit for
	end if
next

'Speicheroptionen
Qualitaet =  FF_GetControl("Stapelbeschnitt","Qualitaet") * 1
boolExifLoeschen = FF_GetControl("Stapelbeschnitt","boolExifLoeschen")

'Markierung
MKgew = FF_GetControl ("Stapelbeschnitt","MKauswahl")
MK_Array = split(StdMarkierung,"/")
for n = 0 to ubound(MK_Array)
	if MK_Array(n) = MKgew then
		MKwert = n
		exit for
	end if
next

'Ablageort
flagAblageV = FF_GetControl("Stapelbeschnitt","flagAblageV")
flagOrigV = FF_GetControl("Stapelbeschnitt","flagOrigV")
Ablage = FF_GetControl ("Stapelbeschnitt","Ablage")

'Speichern
flag_ohneRsp = FF_GetControl("Stapelbeschnitt","flag_ohneRsp")
flag_mPraefix = FF_GetControl("Stapelbeschnitt","flag_mPraefix")
flag_mSuffix = FF_GetControl("Stapelbeschnitt","flag_mSuffix")
PS_Text = FF_GetControl("Stapelbeschnitt","PS_Text")

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen
'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 1

'Seitenverhltnis
Seitenverhaeltnisse = FF_GetProfile (RegSchluessel,"SVnamen")
if Seitenverhaeltnisse = "" then Seitenverhaeltnisse = StdSeitenverhaeltnisse
SeitenverhWerte = FF_GetProfile (RegSchluessel,"SVwerte")
if SeitenverhWerte = "" then SeitenverhWerte = StdSeitenverhWerte
SV_Soll = FF_GetProfile (RegSchluessel,"SVgewhlt")
if SV_Soll = "" then
	Seitenverhaeltnisse = StdSeitenverhaeltnisse
	SeitenverhWerte     = StdSeitenverhWerte
	SV_Soll = "3:2"
end if
'Msgbox Seitenverhaeltnisse & vbNewLine & SeitenverhWerte

'Speicheroptionen
Qualitaet =  FF_GetProfile(RegSchluessel,"Qualitaet")
if Qualitaet = "" then Qualitaet = 0
boolExifLoeschen = FF_GetProfile(RegSchluessel,"boolExifLoeschen")
if boolExifLoeschen = "" then boolExifLoeschen = 0

'Markierung
MKwert =  FF_GetProfile(RegSchluessel,"MKwert")
if MKwert = "" then MKwert = 5

'Ablage
flagOrigV = FF_GetProfile(RegSchluessel,"flagOrigV")
if flagOrigV = "" then flagOrigV = 0
Ablage = FF_GetProfile (RegSchluessel,"Ablage")
if Ablage = "" then Ablage = "C:\"

'Speichern
flag_ohneRsp = FF_GetProfile(RegSchluessel,"flag_ohneRsp")
if flag_ohneRsp = "" then flag_ohneRsp = 0
flag_mPraefix = FF_GetProfile(RegSchluessel,"flag_mPraefix")
if flag_mPraefix = "" then flag_mPraefix = 0
flag_mSuffix = FF_GetProfile(RegSchluessel,"flag_mSuffix")
if flag_mSuffix = "" then flag_mSuffix = 0
PS_Text = FF_GetProfile(RegSchluessel,"PS_Text")
if PS_Text = "" then PS_Text = "Cut"

'### Werte eintragen
'Auswahl
select case Auswahl
	Case 0
		FF_SetControl "Stapelbeschnitt","allCV",1
	Case 1
		FF_SetControl "Stapelbeschnitt","selCV",1
	Case 2
		FF_SetControl "Stapelbeschnitt","allBL",1
	Case 3
		FF_SetControl "Stapelbeschnitt","selBL",1
Case else
End select

'Seitenverhltnisse
SV_Array = split(Seitenverhaeltnisse,"/",-1)
for n = 0 to ubound(SV_Array)-1
	FF_SetControl "Stapelbeschnitt","SVauswahl",SV_Array(n)
next
FF_SetControl "Stapelbeschnitt","SVauswahl",SV_Soll

'Speicheroptionen
FF_SetControl "Stapelbeschnitt","Qualitaet",Qualitaet
FF_SetControl "Stapelbeschnitt","boolExifLoeschen",boolExifLoeschen

'Markierung
MK_Array = split(StdMarkierung,"/")
for n = 0 to ubound(MK_Array)
	FF_SetControl "Stapelbeschnitt","MKauswahl",MK_Array(n)
next
FF_SetControl "Stapelbeschnitt","MKauswahl",MK_Array(MKwert)

'Ablage
FF_SetControl "Stapelbeschnitt","flagOrigV",flagOrigV
if flagOrigV = 1 then 
	FF_SetControl "Stapelbeschnitt","flagOrigV",1
	FF_EnableControl "Stapelbeschnitt","Ablage",false
	FF_EnableControl "Stapelbeschnitt","...",false
else
	FF_SetControl "Stapelbeschnitt","flagAblageV",1
end if
FF_SetControl "Stapelbeschnitt","Ablage",Ablage

'Speichern
FF_SetControl "Stapelbeschnitt","flag_ohneRsp",flag_ohneRsp
FF_SetControl "Stapelbeschnitt","flag_mPraefix",flag_mPraefix
FF_SetControl "Stapelbeschnitt","flag_mSuffix",flag_mSuffix
FF_SetControl "Stapelbeschnitt","PS_Text",PS_Text

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Auswahl
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl

'Seitenverhltnisse und -Werte
FF_WriteProfile RegSchluessel,"SVnamen",Seitenverhaeltnisse
FF_WriteProfile RegSchluessel,"SVwerte",SeitenverhWerte
FF_WriteProfile RegSchluessel,"SVgewhlt",SV_Soll

'Speicheroptionen
FF_WriteProfile RegSchluessel,"Qualitaet",Qualitaet
FF_WriteProfile RegSchluessel,"boolExifLoeschen",boolExifLoeschen

'Markierung
FF_WriteProfile RegSchluessel,"MKwert",MKwert

'Ablage
FF_WriteProfile RegSchluessel,"flagOrigV",flagOrigV
FF_WriteProfile RegSchluessel,"Ablage",Ablage

'Speichern
FF_WriteProfile RegSchluessel,"flag_ohneRsp",flag_ohneRsp
FF_WriteProfile RegSchluessel,"flag_mPraefix",flag_mPraefix
FF_WriteProfile RegSchluessel,"flag_mSuffix",flag_mSuffix
FF_WriteProfile RegSchluessel,"PS_Text",PS_Text

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub Kontrolle
Dim  BAnzahl,Text

Abbruch = false
Bilder = FF_GetSelection(Auswahl)

'Versionstest
if Auswahl > 1 then		'Auswahl aktiver Bilderliste
	if not Version_OK("2.90.00") then
		msgbox "Um die Auswahl aktiver Bilderlisten nutzen zu knnen" & vbNewLine & _
			   "ist mindestens FixFoto-Version 2.90 erforderlich.",vbCritical,"Hinweis"
		Abbruch = true
		exit sub
	end if
end if

'Bild vorhanden?
Bilder = FF_GetSelection(Auswahl)
if Auswahl = 0 or Auswahl = 2 then Text = "vorhanden!" else Text = "markiert!"
if len(Bilder) = 0 then
	msgbox "Es ist kein Bild " & Text,vbExclamation,"Meldung"
	Abbruch = true
	exit sub	
end if

'Qualitt in Ordnung
if Qualitaet = 0 then
elseif Qualitaet < 70 or Qualitaet > 100 then
	msgbox 	"Die vorgegebene Speicherqualitt sollte zwischen 70 und 100 liegen" & vbNewLine & _
			"oder = 0 sein, was dem Einstellungswert bei FF entspricht.",vbCritical,"Hinweis"
	Abbruch = true
	exit sub
end if

'Ablageort vorhanden?
if not objFS.FolderExists(Ablage) then
	msgbox "Der Ablageordner " & Ablage & " existiert nicht!",vbExclamation,"Meldung"
	Abbruch = true
	exit sub
end if	

End Sub
'------------------------------------------------------------------------
Sub Schleife

'Bilder in Array eintragen
ListeBilder = split(Bilder, vbNewLine)
img = ubound(ListeBilder)

for n = 0 to img
	'vorzeitiger Abbruch?
	if FF_CheckKey() = 8 or VAbbruch then 	'8 = Backspace
		Antwort = msgbox("Von " & img +1 & " Bildern wurden bisher " & n & _
					 " Bilder angepasst." & vbNewLine & vbNewLine & _
					 "Soll die weitere Normierung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
		if Antwort = vbYes then Abbruch = true : exit sub
	end if

	'Bearbeitung
	Bild = ListeBilder(n)
	FF_LoadImage Bild
	call Beschnitt
	FF_SetControl "Stapelbeschnitt","Fortschritt",(n+1)/(img+1)*100
next

End Sub
'------------------------------------------------------------------------
Sub Beschnitt
Dim Bildbreite,Bildhoehe,SV_Ist
Dim ZielHoehePx,ZielBreitePx
Dim SParameter,AntwortMD,Schnittwerte

Bildbreite = FF_GetImageWidth
Bildhoehe  = FF_GetImageHeight
SV_Ist = Bildhoehe / Bildbreite

	ZielHoehePx  = Bildhoehe
	if SVwert = "ogn" then
		ZielBreitePx = Bildbreite
	else
		ZielBreitePx = round(Bildhoehe / SVwert)
		if ZielBreitePx > Bildbreite then
			ZielBreitePx = Bildbreite
			ZielHoehePx = round(Bildbreite * SVwert)
		end if
	end if

	if SV_Ist >= 0 then
		SParameter = "0,0," & ZielBreitePx & "," & ZielHoehePx & "," & Bildbreite & "," & Bildhoehe & "," & MKwert & ",1"
	else
		SParameter = "0,0," & ZielHoehePx & "," & ZielBreitePx & "," & Bildbreite & "," & Bildhoehe & "," & MKwert & ",1"
	end if
	
	FF_SetParam SParameter
	AntwortMD = FF_MultiDialog ("MultiCanvas",2)
	if FF_CheckKey() = 8 then VAbbruch = true		'8 = Backspace
	if AntwortMD < 0 then
'		msgbox "Das Bild wurde nicht beschnitten!" & vbNewLine & _
'			   "Es wird ausgelassen.",vbInformation,"Hinweis"
		exit sub
	end if

NurKopieren = false
if NSp_SMgO then
	Schnittwerte = split(FF_GetParam,",")
	if abs(Bildbreite - Schnittwerte(2)*1) <= (Bildbreite*TolSM_Og/100) and _
	   abs(Bildhoehe - Schnittwerte(3)*1) <= (Bildhoehe*TolSM_Og/100) then
'		msgbox "Das Bild wurde nicht beschnitten!" & vbNewLine & _
'			   "Es wird nur in den Ablageort, kopiert.",vbInformation,"Hinweis"
		NurKopieren = true
		BildOriginal = Bild
	end if
end if

call BildSpeichern

End Sub
'------------------------------------------------------------------------
Sub BildSpeichern
Dim Pfad

'Exif-/IPTC-Daten behandeln
if boolExifLoeschen = 1 and not NurKopieren then
	if FF_HasExif then FF_KillExif
	if FF_HasIPTC then FF_KillIPTC
end if

'Ablage
if flagOrigV = 1 then
	Pfad = objFs.GetParentFolderName(Bild) & "\"
else
	Pfad = Ablage
end if

'Name neu
if flag_mPraefix = 1 then Bild = Pfad & PS_Text & objFS.GetFileName(Bild)
if flag_mSuffix = 1 then Bild = Pfad & objFS.GetBaseName(Bild) & PS_Text & "." & objFS.GetExtensionName(Bild)
if flag_mPraefix = 0 and flag_mSuffix = 0 then Bild = Pfad & objFS.GetFileName(Bild)

'existiert Dateiname bereits?
if flag_ohneRsp = 0 then
	if objFS.FileExists(Bild) then
		Antwort = msgbox("Das Bild" & vbNewLine & _
						 """" & Bild & """" & vbNewLine & "existiert bereits." & vbNewLine & vbNewLine & _
						 "Soll es berschrieben werden?",vbYesNo or vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbNo then exit sub
	end if
end if

'Kopieren/Speichern
if NurKopieren then
	if flagAblageV = 1 then objFS.CopyFile BildOriginal,Bild
else
	FF_SaveImage Bild,Qualitaet
	Anzahl = Anzahl + 1	
end if

End Sub
'------------------------------------------------------------------------
Sub Seitenverhaeltnis
'Neues Seitenverhltnis definieren

'** Start Dialog Seitenverhltnis **
FF_AddDialog "Seitenverhltnis",91,50
FF_AddControl "Seitenverhltnis","Benennung","STATIC",8,5,33,11
FF_SetControlStyle "Seitenverhltnis","Benennung",1
FF_AddControl "Seitenverhltnis","Seitenverhltnis","STATIC",43,5,44,11
FF_SetControlStyle "Seitenverhltnis","Seitenverhltnis",1
FF_AddControl "Seitenverhltnis","SVNeuB","SLEDIT",8,17,33,10
FF_AddControl "Seitenverhltnis","SVNeuW","SLEDIT",49,17,33,10
FF_AddControl "Seitenverhltnis","Abbrechen","BUTTON",8,33,33,11
FF_AddControl "Seitenverhltnis","bernehmen","BUTTON",49,33,34,11
'** End Dialog Seitenverhltnis **

FF_ActivateControl "Seitenverhltnis","SVNeuB"

Dim NeuBez,NeuWert,WertArray
do
	Select Case FF_ShowDialog ("Seitenverhltnis")
	Case "bernehmen"
		NeuBez = FF_GetControl ("Seitenverhltnis","SVNeuB")	
		NeuWert = FF_GetControl ("Seitenverhltnis","SVNeuW")
		if len(NeuBez) > 0 and len(NeuWert) > 0 then
			
			NeuBez = trim(NeuBez)
			if instr(NeuBez,"/") > 0 then
				msgbox "Bei der Benennung ist das Zeichen '/' nicht erlaubt." & vbNewLine & _
					   "Es wird daher ersetzt durch das Zeichen ':'.",vbInformation,"Hinweis"
				NeuBez = replace(NeuBez,"/",":")
			end if
			
			NeuWert = trim(NeuWert)
			NeuWert = replace(NeuWert,".",",")
			if SearchRegAusdr (NeuWert,"^[1-9]+[0-9]*\s*[/:]\s*[1-9]+[0-9]*$", False) Then
				if instr(NeuWert,":") > 0 then
					WertArray = split(NeuWert,":")
				elseif instr(NeuWert,"/") > 0 then
					WertArray = split(NeuWert,"/")
				else
					msgbox "Eingabefehler!"
				end if
				NeuWert = round(WertArray(0) / WertArray(1),3)
				if NeuWert < 1 then NeuWert = round(WertArray(1) / WertArray(0),3)
			elseif SearchRegAusdr (NeuWert, "^[0-9]+,[0-9]+$", False) Then
				NeuWert = round(NeuWert,3)
				if NeuWert < 1 then NeuWert = round(1 / NeuWert,3)
			else
				Neuwert = 0
			end if

			if NeuWert >= 1 then
				SeitenverhWerte = SeitenverhWerte & NeuWert & "/" 
				Seitenverhaeltnisse = Seitenverhaeltnisse & NeuBez & "/"
				FF_SetControl "Stapelbeschnitt","SVauswahl",NeuBez
				FF_SetControl "Stapelbeschnitt","SVauswahl",NeuBez
				exit do
			else
				msgbox "Der Seitenverhltniswert ist ungltig!" & vbNewLine & "Es muss eine Dezimalzahl (z.B. 1,25)" & _
												  vbNewLine & "oder ein Verhltnis (z.B. 4 : 3 oder 16 / 9)" & _
												  vbNewLine & "eingegeben werden.",vbInformation,"Info"
			end if
		else
			msgbox "Es muss eine Benennung und ein Seitenverhltnis eingegeben werden!",vbInformation,"Info"
		end if
	Case "CANCEL", "Abbrechen"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Seitenverhltnis")	

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'-------------------------------------------------------------------------
Function SearchRegAusdr(Zeichenfolge, Muster, GrossKleinBeachten)
' Vergleich einer Zeigenfolge mit einem Suchmuster, bei bereinstimmung
' wird True zurckgegeben, sonst False

Dim regAusdr

Set regAusdr = New RegExp
regAusdr.Pattern = Muster
regAusdr.IgnoreCase = GrossKleinBeachten	' Bercksichtigung der Gro-/Kleinschreibung
regAusdr.Global = True						' legt globales Anwenden fest

If regAusdr.Test(Zeichenfolge) then
	SearchRegAusdr = True
Else
	SearchRegAusdr = False
End If

End Function
'---------------------------------------------------------------------------
